#include <FL/Fl_SWM.H>
#include <FL/Fl_Widget_Labeler.H>
#include <FL/Fl.H>
#include <iostream>

class SWM_Test : public Fl_Window,
		 public Fl_SWM_Client,
		 public Fl_Widget_Labeler
{
public:
  SWM_Test(int maxi, int maxj, int butw, const char* t="SWM_Test") :
    Fl_Window((maxi+1)*butw,maxj+2,t),
    Fl_SWM_Client(),
    Fl_Widget_Labeler(256)
  {
    Fl_Button* b;
    for(int i=0; i<=maxi; ++i) {
      for(int j=0; j<=maxj; ++j) {
	b = new Fl_Button(i*butw, j, butw, 1);
	labelf_widget(b, "%d , %d", i, j);
	b->callback((Fl_Callback*)s_Spit, (void*)(i*j));
      }
    }
    b = new Fl_Button(10,maxj+1,5,1, "Show");
    set_swm_show_cb(b);
    b = new Fl_Button(15,maxj+1,7,1, "HotSpot");
    set_swm_hotspot_cb(b);
  }

  static void s_Spit(Fl_Button* b, int i) { std::cout << i << std::endl; }
};

main(int argc, char** argv) {
  Fl_SWM_Manager x;
  x.show_ctrl();
  SWM_Test w1(5,5,5,"W1"), w2(10,10,7,"W2");
  x.adopt_window(&w1); x.adopt_window(&w2);
  w1.show(); w2.show();
  Fl::run();
}
